package dev.shadowsoffire.apotheosis.adventure.loot;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.serialization.Codec;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketHelper;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import java.util.function.Supplier;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.level.storage.loot.parameters.LootContextParams;
import net.minecraftforge.common.loot.IGlobalLootModifier;
import net.minecraftforge.common.loot.LootModifier;

public class AffixHookLootModifier extends LootModifier {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.loot.AffixHookLootModifier> CODEC = Codec.unit(dev.shadowsoffire.apotheosis.adventure.loot.AffixHookLootModifier::new);
  
  protected AffixHookLootModifier() {
    super(new net.minecraft.world.level.storage.loot.predicates.LootItemCondition[0]);
  }
  
  protected ObjectArrayList<ItemStack> doApply(ObjectArrayList<ItemStack> generatedLoot, LootContext ctx) {
    if (!Apotheosis.enableAdventure)
      return generatedLoot; 
    if (ctx.m_78936_(LootContextParams.f_81463_)) {
      ItemStack tool = (ItemStack)ctx.m_165124_(LootContextParams.f_81463_);
      SocketHelper.getGems(tool).modifyLoot(generatedLoot, ctx);
      AffixHelper.streamAffixes(tool).forEach(inst -> inst.modifyLoot(generatedLoot, ctx));
    } 
    return generatedLoot;
  }
  
  public Codec<? extends IGlobalLootModifier> codec() {
    return (Codec)CODEC;
  }
}
